package squid3 failed to install/upgrade: dependency problems - leaving triggers unprocessed

Bug #1571174 reported by Alexander List on 2016-04-16
184
This bug affects 32 people
Affects Status Importance Assigned to Milestone
dpkg (Ubuntu)
Undecided
Unassigned
Xenial
Undecided
Unassigned
squid3 (Ubuntu)
High
Robie Basak
Xenial
High
Robie Basak

Bug Description

[ SRU Justification ]
Older versions of ufw had an interest-await trigger, causing trigger loops in some cases, especially the case of upgrading squid3.

The newer version fixed this, however if squid is upgraded first, that's no help.

[ Test Case ]
== In a wily chroot with updates/security enabled ==
apt-get install ufw squid3
sed -i -e 's/wily/xenial/g' /etc/apt/sources.list
apt-get update
apt-get dist-upgrade

== Repeat the above with xenial-proposed added before the upgrade ==
Should succeed if either squid or dpkg have been updated for the Breaks.

[ Test Case 2 ]

[racb] I noticed that this doesn't reproduce every time, so try it a few times.

Steps to reproduce:

lxc launch ubuntu:wily squid3-upgrade
lxc exec squid3-upgrade bash
apt-get update && apt-get -y dist-upgrade
apt-get install -y squid3 ufw
sed -i s/wily/xenial/g /etc/apt/sources.list
apt-get update
systemctl mask systemd-sysctl.service # workaround for LP: #1580984
DEBIAN_FRONTEND=noninteractive apt-get -y -o DPkg::options::=--force-confnew dist-upgrade

Expected result: success

Actual result:

dpkg: dependency problems prevent processing triggers for ufw:
 ufw depends on python3; however:
  Package python3 is not configured yet.
 ufw depends on python3:any (>= 3.3.2-2~); however:
  Package python3 is not configured yet.

dpkg: error processing archive /var/cache/apt/archives/squid3_3.5.12-1ubuntu7_all.deb (--unpack):
 dependency problems - leaving triggers unprocessed
E: Sub-process /usr/bin/dpkg returned an error code (1)

Cleanup after test:

exit
lxc delete -f squid3-upgrade

[ Original Report ]
During an upgrade from 15.10 to 16.04, upgrading squid3 erred out...

ProblemType: Package
DistroRelease: Ubuntu 16.04
Package: squid3 3.3.8-1ubuntu16.2
ProcVersionSignature: Ubuntu 4.2.0-34.39-generic 4.2.8-ckt4
Uname: Linux 4.2.0-34-generic x86_64
ApportVersion: 2.19.1-0ubuntu5
Architecture: amd64
Date: Sat Apr 16 05:33:51 2016
DuplicateSignature: package:squid3:3.3.8-1ubuntu16.2:dependency problems - leaving triggers unprocessed
ErrorMessage: dependency problems - leaving triggers unprocessed
InstallationDate: Installed on 2015-12-07 (131 days ago)
InstallationMedia: Ubuntu-Server 15.10 "Wily Werewolf" - Release amd64 (20151021)
RelatedPackageVersions:
 dpkg 1.18.4ubuntu1
 apt 1.2.10ubuntu1
SourcePackage: squid3
Title: package squid3 3.3.8-1ubuntu16.2 failed to install/upgrade: dependency problems - leaving triggers unprocessed
UpgradeStatus: Upgraded to xenial on 2016-04-16 (0 days ago)
modified.conffile..etc.apparmor.d.usr.sbin.squid3: [deleted]
modified.conffile..etc.init.d.squid3: [deleted]
modified.conffile..etc.init.squid3.conf: [deleted]
modified.conffile..etc.logrotate.d.squid3: [deleted]
modified.conffile..etc.resolvconf.update.libc.d.squid3: [deleted]
modified.conffile..etc.squid3.errorpage.css: [deleted]
modified.conffile..etc.squid3.msntauth.conf: [deleted]
modified.conffile..etc.squid3.squid.conf: [deleted]
modified.conffile..etc.ufw.applications.d.squid3: [deleted]

Alexander List (alexlist) wrote :
Alexander List (alexlist) wrote :

Continuing the upgrade with

apt-get -f install
apt-get dist-upgrade

completed without further errors.

tags: removed: need-duplicate-check
Alexander List (alexlist) wrote :

I tried the same again in a Docker container:

1.) docker run --privileged -ti ubuntu:15.10 /bin/bash
2.) apt-get update; apt-get -y dist-upgrade
3.) apt-get install ufw squid-deb-proxy wget
4.) service squid-deb-proxy start
5.) wget http://archive.ubuntu.com/ubuntu/pool/main/u/ufw/ufw_0.35-0ubuntu2_all.deb
6.) dpkg -i ufw_0.35-0ubuntu2_all.deb
7.) due to https://bugs.launchpad.net/ubuntu/+source/ubuntu-release-upgrader/+bug/1570947 did
export SUDO_USER=root
export SUDO_UID=0
export SUDO_COMMAND=/bin/bash
export SUDO_GID=0
8.) do-release-upgrade -d

completed without further errors. --> upgrading ufw before squid helps

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in squid3 (Ubuntu):
status: New → Confirmed
Changed in squid3 (Ubuntu):
importance: Undecided → High
Amos Jeffries (yadi) on 2016-05-01
summary: - package squid3 3.3.8-1ubuntu16.2 failed to install/upgrade: dependency
- problems - leaving triggers unprocessed
+ package squid3 failed to install/upgrade: dependency problems - leaving
+ triggers unprocessed
Robie Basak (racb) wrote :

15:32 <rbasak> "dpkg: dependency problems prevent processing triggers for ufw"

15:32 <rbasak> Is this an apt bug? I don't see an obvious packaging deficiency or opportunity for there to be a dependency loop.

15:33 <rbasak> http://paste.ubuntu.com/16218132/ is my reproduction of bug 1571174

15:35 <rbasak> It seems to me that apt should have chosen to configure python3 first.

Changed in squid3 (Ubuntu):
status: Confirmed → Triaged
Robie Basak (racb) wrote :

Michael, may I have your opinion on this please?

LaMont Jones (lamont) wrote :

This also affects trusty->xenial upgrades (see 1575946)

Thanks guys, but a new brand instalation of 16.04 solved my problem.
Well... make a upgrade or re-install, theres the question. Thank you
masters.

2016-05-09 16:29 GMT+01:00 LaMont Jones <email address hidden>:

> This also affects trusty->xenial upgrades (see 1575946)
>
> --
> You received this bug notification because you are subscribed to a
> duplicate bug report (1573525).
> https://bugs.launchpad.net/bugs/1571174
>
> Title:
> package squid3 failed to install/upgrade: dependency problems -
> leaving triggers unprocessed
>
> Status in squid3 package in Ubuntu:
> Triaged
>
> Bug description:
> During an upgrade from 15.10 to 16.04, upgrading squid3 erred out...
>
> ProblemType: Package
> DistroRelease: Ubuntu 16.04
> Package: squid3 3.3.8-1ubuntu16.2
> ProcVersionSignature: Ubuntu 4.2.0-34.39-generic 4.2.8-ckt4
> Uname: Linux 4.2.0-34-generic x86_64
> ApportVersion: 2.19.1-0ubuntu5
> Architecture: amd64
> Date: Sat Apr 16 05:33:51 2016
> DuplicateSignature: package:squid3:3.3.8-1ubuntu16.2:dependency problems
> - leaving triggers unprocessed
> ErrorMessage: dependency problems - leaving triggers unprocessed
> InstallationDate: Installed on 2015-12-07 (131 days ago)
> InstallationMedia: Ubuntu-Server 15.10 "Wily Werewolf" - Release amd64
> (20151021)
> RelatedPackageVersions:
> dpkg 1.18.4ubuntu1
> apt 1.2.10ubuntu1
> SourcePackage: squid3
> Title: package squid3 3.3.8-1ubuntu16.2 failed to install/upgrade:
> dependency problems - leaving triggers unprocessed
> UpgradeStatus: Upgraded to xenial on 2016-04-16 (0 days ago)
> modified.conffile..etc.apparmor.d.usr.sbin.squid3: [deleted]
> modified.conffile..etc.init.d.squid3: [deleted]
> modified.conffile..etc.init.squid3.conf: [deleted]
> modified.conffile..etc.logrotate.d.squid3: [deleted]
> modified.conffile..etc.resolvconf.update.libc.d.squid3: [deleted]
> modified.conffile..etc.squid3.errorpage.css: [deleted]
> modified.conffile..etc.squid3.msntauth.conf: [deleted]
> modified.conffile..etc.squid3.squid.conf: [deleted]
> modified.conffile..etc.ufw.applications.d.squid3: [deleted]
>
> To manage notifications about this bug go to:
>
> https://bugs.launchpad.net/ubuntu/+source/squid3/+bug/1571174/+subscriptions
>

--
Paulo Machado

Robie Basak (racb) wrote :

16:30 <infinity> rbasak: It's not your fault (not apt's), it's ufw's. Or, more annoyingly, it's that we need to sort out how to upgrade ufw early.

16:33 <infinity> rbasak: Fixing this specific case could be done by having squid Breaks << the new ufw, but that's a lie. If the upgrades are happening in the right order, I can do the Breaks from dpkg, but that might not help wily->xenial. I'll ponder a fix that will more globally be correct.

Robie Basak (racb) wrote :

10:47 <infinity> rbasak: If you want a quick workaround, just SRU squid to
                 Breaks: ufw (<< 0.35-0ubuntu2)

10:47 <infinity> rbasak: I'm sitll pondering a more sane global solution.

Robie Basak (racb) wrote :

This will need a Xenial SRU to fix the upgrade path, but does not affect Yakkety since all (supported) upgrade paths go through Xenial.

Changed in squid3 (Ubuntu):
status: Triaged → In Progress
assignee: nobody → Robie Basak (racb)
Changed in squid3 (Ubuntu Xenial):
status: New → In Progress
importance: Undecided → High
Changed in squid3 (Ubuntu):
status: In Progress → Invalid
Adam Conrad (adconrad) on 2016-05-12
Changed in dpkg (Ubuntu):
status: New → Invalid

Hello Alexander, or anyone else affected,

Accepted dpkg into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/dpkg/1.18.4ubuntu1.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in dpkg (Ubuntu Xenial):
status: New → Fix Committed
tags: added: verification-needed
Adam Conrad (adconrad) on 2016-05-12
description: updated
Adam Conrad (adconrad) wrote :

Confirmed that dpkg in xenial-proposed fixes this for me. Once we get some decent autopkgtest coverage, I'll release it into the wild.

Robie Basak (racb) wrote :

squid3 fix uploaded to Xenial.

description: updated
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package dpkg - 1.18.4ubuntu1.1

---------------
dpkg (1.18.4ubuntu1.1) xenial; urgency=medium

    * Add Breaks on ufw (<< 0.35-0ubuntu2~) for trigger loops (LP: #1571174)

 -- Adam Conrad <email address hidden> Thu, 12 May 2016 04:35:55 -0600

Changed in dpkg (Ubuntu Xenial):
status: Fix Committed → Fix Released
Adam Conrad (adconrad) wrote :

Hello Alexander, or anyone else affected,

Accepted squid3 into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/squid3/3.5.12-1ubuntu7.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in squid3 (Ubuntu Xenial):
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package squid3 - 3.5.12-1ubuntu7.1

---------------
squid3 (3.5.12-1ubuntu7.1) xenial; urgency=medium

  * Add Breaks on older ufw to fix upgrade path (LP: #1571174).

 -- Robie Basak <email address hidden> Thu, 12 May 2016 11:03:06 +0000

Changed in squid3 (Ubuntu):
status: Invalid → Fix Released
Marc Deslauriers (mdeslaur) wrote :

Could someone please test the package in xenial-proposed? I am preparing security updates for squid3 and if it's not tested, it will get superseded. Thanks!

Robie Basak (racb) on 2016-06-07
Changed in squid3 (Ubuntu Xenial):
assignee: nobody → Robie Basak (racb)
Robie Basak (racb) wrote :

I don't seem to be able to reproduce the original bug. This is likely due to the dpkg fix in 1.18.4ubuntu1.1 that has already landed. However we know that there could exist edge cases that would still cause an upgrade failure without the Breaks clause, so I think this SRU is still worth landing. I have verified that, with squid installed, I can upgrade to xenial-proposed from wily (using apt-get dist-upgrade after manipulating sources.list).

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package squid3 - 3.5.12-1ubuntu7.1

---------------
squid3 (3.5.12-1ubuntu7.1) xenial; urgency=medium

  * Add Breaks on older ufw to fix upgrade path (LP: #1571174).

 -- Robie Basak <email address hidden> Thu, 12 May 2016 11:03:06 +0000

Changed in squid3 (Ubuntu Xenial):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for squid3 has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers